'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.backToTopStyles = undefined;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react3 = require('@s-ui/js/lib/react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-AtomBackToTop';
var CLASS_ICON = BASE_CLASS + '-icon';
var CLASS_TEXT = BASE_CLASS + '-text';
var CLASS_SHOW = BASE_CLASS + '--show';
var CLASS_HIDE = BASE_CLASS + '--hide';
var CLASS_HOVER = CLASS_SHOW + '--hover';
var CLASS_READY = BASE_CLASS + '--ready';

var STYLES = {
  DARK: 'dark',
  LIGHT: 'light'
};

var AtomBackToTop = function (_PureComponent) {
  (0, _inherits3.default)(AtomBackToTop, _PureComponent);

  function AtomBackToTop() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, AtomBackToTop);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = AtomBackToTop.__proto__ || (0, _getPrototypeOf2.default)(AtomBackToTop)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      show: null,
      hover: false
    }, _this.intervalId = 0, _this.container = null, _this.scrollStep = function () {
      var scrollTop = _this.container.scrollTop;
      var scrollSteps = _this.props.scrollSteps;
      var _this2 = _this,
          intervalId = _this2.intervalId;


      if (scrollTop === 0) clearInterval(intervalId);
      _this.container.scrollTop = scrollTop - scrollSteps;
    }, _this.scrollToTop = function () {
      var _this3 = _this,
          scrollStep = _this3.scrollStep;
      var scrollIntervalTime = _this.props.scrollIntervalTime;

      _this.intervalId = setInterval(scrollStep, scrollIntervalTime);
    }, _this.handleScroll = function (halfHeight) {
      var scrollTop = _this.container.scrollTop;
      var show = _this.state.show;


      if (scrollTop > halfHeight) {
        if (!show) _this.setState({ show: true });
      } else {
        if (show) _this.setState({ show: false, hover: false });
      }
    }, _this.hoverButton = function (e) {
      _this.setState({ hover: true });
    }, _this.unhoverButton = function (e) {
      _this.setState({ hover: false });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(AtomBackToTop, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.container = (0, _react3.getTarget)(this.props.refContainer);

      var handleScroll = this.handleScroll;
      var _container = this.container,
          scrollHeight = _container.scrollHeight,
          clientHeight = _container.clientHeight;

      var halfHeight = Math.floor((scrollHeight - clientHeight) / 2);

      this.container.addEventListener('scroll', handleScroll.bind(this, halfHeight));
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var handleScroll = this.handleScroll,
          intervalId = this.intervalId;

      clearInterval(intervalId);
      this.container.removeEventListener('scroll', handleScroll);
    }
  }, {
    key: 'render',
    value: function render() {
      var scrollToTop = this.scrollToTop,
          hoverButton = this.hoverButton,
          unhoverButton = this.unhoverButton;
      var _props = this.props,
          IconTop = _props.iconTop,
          textTop = _props.textTop,
          style = _props.style;
      var _state = this.state,
          show = _state.show,
          hover = _state.hover;

      return _react2.default.createElement(
        'button',
        {
          title: 'Back to top',
          className: (0, _classnames2.default)(BASE_CLASS, BASE_CLASS + '--' + style, show !== null && CLASS_READY, show ? CLASS_SHOW : CLASS_HIDE, hover && CLASS_HOVER),
          onMouseOver: hoverButton,
          onMouseOut: unhoverButton,
          onClick: scrollToTop
        },
        IconTop && _react2.default.createElement(
          'span',
          { className: CLASS_ICON },
          _react2.default.createElement(IconTop, null)
        ),
        textTop && _react2.default.createElement(
          'span',
          { className: CLASS_TEXT },
          textTop
        )
      );
    }
  }]);
  return AtomBackToTop;
}(_react.PureComponent);

AtomBackToTop.displayName = 'AtomBackToTop';

AtomBackToTop.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /** Icon (component) to be displayed */
  iconTop: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),

  /** Text to be displayed */
  textTop: _propTypes2.default.string,

  /** Number of pixels which will be scrolled on every step */
  scrollSteps: _propTypes2.default.number,

  /** Time in ms which will be scrolled a step */
  scrollIntervalTime: _propTypes2.default.number,

  /** Container to be scrolled. Can be a selector, or a React ref object */
  refContainer: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),

  /**
   * Styles
   *  DARK → 'dark'
   *  LIGHT →'light'
   */
  style: _propTypes2.default.oneOf((0, _values2.default)(STYLES))
} : {} : {};

AtomBackToTop.defaultProps = {
  refContainer: document.body,
  style: STYLES.DARK,
  scrollIntervalTime: 50,
  scrollSteps: 100
};

exports.backToTopStyles = STYLES;
exports.default = AtomBackToTop;